package com.jiuqi.util.comparator;

import java.util.Comparator;

public final class StringComparator implements Comparator {
   private boolean isDescOrder;
   private boolean ignoreCase;

   public StringComparator() {
   }

   public StringComparator(boolean isDescOrder) {
      this.isDescOrder = isDescOrder;
   }

   public StringComparator(boolean isDescOrder, boolean ignoreCase) {
      this.isDescOrder = isDescOrder;
      this.ignoreCase = ignoreCase;
   }

   public int compare(Object o1, Object o2) {
      if (o1 == o2) {
         return 0;
      } else {
         int ret = false;
         int ret;
         if (o1 == null) {
            ret = -1;
         } else if (o2 == null) {
            ret = 1;
         } else {
            ret = this.ignoreCase ? ((String)o1).compareToIgnoreCase((String)o2) : ((String)o1).compareTo((String)o2);
         }

         return this.isDescOrder ? -ret : ret;
      }
   }

   public boolean equals(Object obj) {
      if (this == obj) {
         return true;
      } else if (this != null && obj != null) {
         if (obj instanceof StringComparator) {
            StringComparator cmp = (StringComparator)obj;
            return cmp.ignoreCase == this.ignoreCase && cmp.isDescOrder == this.isDescOrder;
         } else {
            return false;
         }
      } else {
         return false;
      }
   }

   public String toString() {
      return "[字符串比较器, " + (this.isDescOrder ? "降序" : "升序") + (this.ignoreCase ? ", 忽略大小写]" : "]");
   }

   public boolean isDescOrder() {
      return this.isDescOrder;
   }

   public void setDescOrder(boolean isDescOrder) {
      this.isDescOrder = isDescOrder;
   }

   public boolean isIgnoreCase() {
      return this.ignoreCase;
   }

   public void setIgnoreCase(boolean ignoreCase) {
      this.ignoreCase = ignoreCase;
   }
}
